<script setup lang="ts">
////////////////////////////////
// IMPORT
////////////////////////////////

import { useNodeStore } from "@/stores/useNodeStore";
import { useNotificationStore } from "@/stores/useNotificationStore";
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";

////////////////////////////////
// PROPS
////////////////////////////////

const props = defineProps({
  newWorkspaceDialog: {
    type: Boolean,
    required: true,
  },
});

////////////////////////////////
// EMITS
////////////////////////////////

const emits = defineEmits(["newWorkspaceDialog"]);

////////////////////////////////
// DATA
////////////////////////////////
const workspaceStore = useWorkspaceStore();
const nodeStore = useNodeStore();
const notificationStore = useNotificationStore();

const drawer = ref(false);

const workspace = ref("");

////////////////////////////////
// WATCH
////////////////////////////////

watch(
  () => props.newWorkspaceDialog,
  (newValue) => {
    drawer.value = newValue;
  },
);

////////////////////////////////
// METHODS
////////////////////////////////

// The `close` method is responsible for closing the dialog by setting the
// `drawer` data property to `false`. It also emits an event called
// "newWorkspaceDialog" with a value of `false` to notify the parent
// component that the dialog has been closed.
function close() {
  drawer.value = false;
  emits("newWorkspaceDialog", false);
  workspace.value = "";
}

// The `newWorkspace` method is responsible for creating a new workspace using
// the `createWorkspace` method of the `workspaceStore`. Finally, it navigates
// to the newly created workspace.
async function newWorkspace() {
  const WorkspaceObjet = await workspaceStore.createWorkspace(workspace.value, "");
  workspaceStore.currentWSlug = WorkspaceObjet.slug;
  nodeStore.fetchNodes();
  notificationStore.fetchNotifications("archived=False");
  await navigateTo(`/${WorkspaceObjet.slug}`);
  close();
}
</script>

<template>
  <v-dialog
    v-model="drawer"
    width="50%"
    persistent
  >
    <v-card>
      <v-card-title class="d-flex">
        <v-sheet
          class="me-auto"
          style="
            overflow: hidden;
            white-space: nowrap;
            text-overflow: ellipsis;
            width: calc(100%-30);
          "
        >
          {{ $t("new_workspace") }}
        </v-sheet>
        <v-sheet>
          <v-btn
            icon="$close"
            density="comfortable"
            variant="plain"
            @click="close"
          />
        </v-sheet>
      </v-card-title>
      <v-card-text>
        <p class="mb-4">
          {{ $t("welcome_text_3") }}
        </p>
        <v-text-field
          v-model="workspace"
          :label="$t('workspace_name')"
          variant="solo"
          autofocus
          :rules="[(v) => !!v || $t('workspace_name_required')]"
          @keydown.enter.prevent="newWorkspace"
        />
        <div class="d-flex flex-row-reverse">
          <v-btn
            color="primary"
            class="mt-2"
            @click="newWorkspace()"
          >
            Create
          </v-btn>
        </div>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>
